package com.adventurer_engine.common.entity.ai.branch_nodes.control;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import com.adventurer_engine.common.entity.ai.AIObject;
import com.adventurer_engine.common.entity.ai.NodeBase;
import com.adventurer_engine.common.entity.ai.NodeStatus;
import com.adventurer_engine.common.entity.ai.branch_nodes.BranchNode;
import com.adventurer_engine.common.entity.ai.branch_nodes.ControlNode;

public class SequenceNode extends ControlNode {
  private int currentIdx = 0;
  
  public static final String INTERNAL_NAME = "sequence";
  
  public SequenceNode(AIObject ai) {
    super(ai);
  }
  
  public NodeStatus onChildReportRUNNING() {
    return NodeStatus.RUNNING;
  }
  
  public NodeStatus onChildReportSUCCESS() {
    if (++this.currentIdx >= this.child.size()) {
      this.currentIdx = 0;
      BranchNode parent = getParent();
      parent.actionTick(NodeStatus.SUCCESS);
      return NodeStatus.SUCCESS;
    } 
    return executeChildNode(this.currentIdx);
  }
  
  public NodeStatus onChildReportFAILURE() {
    BranchNode parent = getParent();
    parent.actionTick(NodeStatus.FAILURE);
    return NodeStatus.FAILURE;
  }
  
  public NodeStatus onParentSendInit() {
    if (this.child.isEmpty()) {
      BranchNode parent = getParent();
      parent.actionTick(NodeStatus.SUCCESS);
      return NodeStatus.SUCCESS;
    } 
    return executeChildNode(this.currentIdx);
  }
  
  public void reset() {
    super.reset();
    this.currentIdx = 0;
  }
  
  public String internalName() {
    return "sequence";
  }
  
  public NodeBase copy(AIObject ai) {
    com.adventurer_engine.common.entity.ai.branch_nodes.control.SequenceNode node = new com.adventurer_engine.common.entity.ai.branch_nodes.control.SequenceNode(ai);
    node.child = copyChild(ai);
    return (NodeBase)node;
  }
}
